Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2511)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2512)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! upper bounds of cross section and 3d output changed from nx+1,ny+1 to nx,ny
+! no output of ghost layer data
+! 
+! 2504 2017-09-27 10:36:13Z maronga
 ! Support roots and water under pavement. Added several pavement types.
 ! 
@@ -3886,5 +3890,5 @@
     LOGICAL      ::  two_d !< flag parameter that indicates 2D variables (horizontal cross sections)
 
-    REAL(wp), DIMENSION(nxlg:nxrg,nysg:nyng,nzb:nzt+1) ::  local_pf !< 
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< 
 
 
@@ -3903,6 +3907,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = c_liq_av(j,i)
                 ENDDO
@@ -3921,6 +3925,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = c_soil_av(j,i)
                 ENDDO
@@ -3939,6 +3943,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = c_veg_av(j,i)
                 ENDDO
@@ -3957,6 +3961,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = ghf_av(j,i)
                 ENDDO
@@ -3975,6 +3979,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = lai_av(j,i)
                 ENDDO
@@ -3993,6 +3997,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = m_liq_av(j,i)
                 ENDDO
@@ -4013,6 +4017,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    DO k = nzb_soil, nzt_soil
                       local_pf(i,j,k) = m_soil_av(k,j,i)
@@ -4035,6 +4039,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng 
+             DO  i = nxl, nxr
+                DO  j = nys, nyn 
                    local_pf(i,j,nzb+1) =  qsws_liq_av(j,i)
                 ENDDO
@@ -4053,6 +4057,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng 
+             DO  i = nxl, nxr
+                DO  j = nys, nyn 
                    local_pf(i,j,nzb+1) =  qsws_soil_av(j,i)
                 ENDDO
@@ -4071,6 +4075,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng 
+             DO  i = nxl, nxr
+                DO  j = nys, nyn 
                    local_pf(i,j,nzb+1) =  qsws_veg_av(j,i)
                 ENDDO
@@ -4090,6 +4094,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = r_a_av(j,i)
                 ENDDO
@@ -4108,6 +4112,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    local_pf(i,j,nzb+1) = r_s_av(j,i)
                 ENDDO
@@ -4128,6 +4132,6 @@
              ENDDO
           ELSE
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    DO k = nzb_soil, nzt_soil
                       local_pf(i,j,k) = t_soil_av(k,j,i)
@@ -4177,5 +4181,5 @@
     LOGICAL      ::  found !< 
 
-    REAL(sp), DIMENSION(nxlg:nxrg,nysg:nyng,nzb_soil:nzt_soil) ::  local_pf !< 
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_soil:nzt_soil) ::  local_pf !< 
 
 
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 2511)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 2512)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! upper bounds of cross section and 3d output changed from nx+1,ny+1 to nx,ny
+! no output of ghost layer data any more
+! 
+! 2302 2017-07-03 14:07:20Z suehring
 ! Reading of 3D topography using NetCDF data type NC_BYTE
 ! 
@@ -1307,5 +1311,5 @@
 !
 !--       Define x-axis (for scalar position)
-          CALL netcdf_create_dim( id_set_3d(av), 'x', nx+2, id_dim_x_3d(av),   &
+          CALL netcdf_create_dim( id_set_3d(av), 'x', nx+1, id_dim_x_3d(av),   &
                                   73 )
           CALL netcdf_create_var( id_set_3d(av), (/ id_dim_x_3d(av) /), 'x',   &
@@ -1314,5 +1318,5 @@
 !
 !--       Define x-axis (for u position)
-          CALL netcdf_create_dim( id_set_3d(av), 'xu', nx+2, id_dim_xu_3d(av), &
+          CALL netcdf_create_dim( id_set_3d(av), 'xu', nx+1, id_dim_xu_3d(av), &
                                   358 )
           CALL netcdf_create_var( id_set_3d(av), (/ id_dim_xu_3d(av) /), 'xu', &
@@ -1321,5 +1325,5 @@
 !
 !--       Define y-axis (for scalar position)
-          CALL netcdf_create_dim( id_set_3d(av), 'y', ny+2, id_dim_y_3d(av),   &
+          CALL netcdf_create_dim( id_set_3d(av), 'y', ny+1, id_dim_y_3d(av),   &
                                   76 )
           CALL netcdf_create_var( id_set_3d(av), (/ id_dim_y_3d(av) /), 'y',   &
@@ -1328,5 +1332,5 @@
 !
 !--       Define y-axis (for v position)
-          CALL netcdf_create_dim( id_set_3d(av), 'yv', ny+2, id_dim_yv_3d(av), &
+          CALL netcdf_create_dim( id_set_3d(av), 'yv', ny+1, id_dim_yv_3d(av), &
                                   361 )
           CALL netcdf_create_var( id_set_3d(av), (/ id_dim_yv_3d(av) /), 'yv', &
@@ -1537,7 +1541,7 @@
 !
 !--          Write data for x (shifted by +dx/2) and xu axis
-             ALLOCATE( netcdf_data(0:nx+1) )
-
-             DO  i = 0, nx+1
+             ALLOCATE( netcdf_data(0:nx) )
+
+             DO  i = 0, nx
                 netcdf_data(i) = ( i + 0.5 ) * dx
              ENDDO
@@ -1545,8 +1549,8 @@
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_x_3d(av),  &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ nx+2 /) )
+                                     count = (/ nx+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 83 )
 
-             DO  i = 0, nx+1
+             DO  i = 0, nx
                 netcdf_data(i) = i * dx
              ENDDO
@@ -1554,5 +1558,5 @@
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_xu_3d(av), &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ nx+2 /) )
+                                     count = (/ nx+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 385 )
 
@@ -1561,7 +1565,7 @@
 !
 !--          Write data for y (shifted by +dy/2) and yv axis
-             ALLOCATE( netcdf_data(0:ny+1) )
-
-             DO  i = 0, ny+1
+             ALLOCATE( netcdf_data(0:ny) )
+
+             DO  i = 0, ny
                 netcdf_data(i) = ( i + 0.5_wp ) * dy
              ENDDO
@@ -1569,8 +1573,8 @@
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_y_3d(av),  &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ ny+2 /) )
+                                     count = (/ ny+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 84 )
 
-             DO  i = 0, ny+1
+             DO  i = 0, ny
                 netcdf_data(i) = i * dy
              ENDDO
@@ -1578,5 +1582,5 @@
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_yv_3d(av), &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ ny+2 /))
+                                     count = (/ ny+1 /))
              CALL netcdf_handle_error( 'netcdf_define_header', 387 )
 
@@ -1612,48 +1616,48 @@
                netcdf_data_format > 4 )  THEN
 
-             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zusi_3d(av),     &
-                                        zu_s_inner(nxl:nxr+1,nys:nyn),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
-             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zusi_3d(av),     &
-                                        zu_s_inner(nxl:nxr,nys:nyn+1),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
-             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zusi_3d(av),     &
-                                        zu_s_inner(nxl:nxr+1,nys:nyn+1),       &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
-             ELSE
+!             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zusi_3d(av),     &
+!                                        zu_s_inner(nxl:nxr+1,nys:nyn),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
+!             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zusi_3d(av),     &
+!                                        zu_s_inner(nxl:nxr,nys:nyn+1),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
+!             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zusi_3d(av),     &
+!                                        zu_s_inner(nxl:nxr+1,nys:nyn+1),       &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
+!             ELSE
                 nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zusi_3d(av),     &
                                         zu_s_inner(nxl:nxr,nys:nyn),           &
                                         start = (/ nxl+1, nys+1 /),            &
                                         count = (/ nxr-nxl+1, nyn-nys+1 /) )
-             ENDIF
+!             ENDIF
              CALL netcdf_handle_error( 'netcdf_define_header', 419 )
 
-             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av),     &
-                                        zw_w_inner(nxl:nxr+1,nys:nyn),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
-             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av),     &
-                                        zw_w_inner(nxl:nxr,nys:nyn+1),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
-             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av),     &
-                                        zw_w_inner(nxl:nxr+1,nys:nyn+1),       &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
-             ELSE
+!             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av),     &
+!                                        zw_w_inner(nxl:nxr+1,nys:nyn),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
+!             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av),     &
+!                                        zw_w_inner(nxl:nxr,nys:nyn+1),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
+!             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av),     &
+!                                        zw_w_inner(nxl:nxr+1,nys:nyn+1),       &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
+!             ELSE
                 nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av),     &
                                         zw_w_inner(nxl:nxr,nys:nyn),           &
                                         start = (/ nxl+1, nys+1 /),            &
                                         count = (/ nxr-nxl+1, nyn-nys+1 /) )
-             ENDIF
+!             ENDIF
              CALL netcdf_handle_error( 'netcdf_define_header', 420 )
 
@@ -1961,5 +1965,5 @@
 !
 !--       Define x-axis (for scalar position)
-          CALL netcdf_create_dim( id_set_xy(av), 'x', nx+2, id_dim_x_xy(av),   &
+          CALL netcdf_create_dim( id_set_xy(av), 'x', nx+1, id_dim_x_xy(av),   &
                                   113 )
           CALL netcdf_create_var( id_set_xy(av), (/ id_dim_x_xy(av) /), 'x',   &
@@ -1968,5 +1972,5 @@
 !
 !--       Define x-axis (for u position)
-          CALL netcdf_create_dim( id_set_xy(av), 'xu', nx+2,                   &
+          CALL netcdf_create_dim( id_set_xy(av), 'xu', nx+1,                   &
                                   id_dim_xu_xy(av), 388 )
           CALL netcdf_create_var( id_set_xy(av), (/ id_dim_xu_xy(av) /), 'xu', &
@@ -1975,5 +1979,5 @@
 !
 !--       Define y-axis (for scalar position)
-          CALL netcdf_create_dim( id_set_xy(av), 'y', ny+2, id_dim_y_xy(av),   &
+          CALL netcdf_create_dim( id_set_xy(av), 'y', ny+1, id_dim_y_xy(av),   &
                                   116 )
           CALL netcdf_create_var( id_set_xy(av), (/ id_dim_y_xy(av) /), 'y',   &
@@ -1982,5 +1986,5 @@
 !
 !--       Define y-axis (for scalar position)
-          CALL netcdf_create_dim( id_set_xy(av), 'yv', ny+2,                   &
+          CALL netcdf_create_dim( id_set_xy(av), 'yv', ny+1,                   &
                                   id_dim_yv_xy(av), 364 )
           CALL netcdf_create_var( id_set_xy(av), (/ id_dim_yv_xy(av) /), 'yv', &
@@ -2255,7 +2259,7 @@
 !
 !--          Write data for x (shifted by +dx/2) and xu axis
-             ALLOCATE( netcdf_data(0:nx+1) )
-
-             DO  i = 0, nx+1
+             ALLOCATE( netcdf_data(0:nx) )
+
+             DO  i = 0, nx
                 netcdf_data(i) = ( i + 0.5_wp ) * dx
              ENDDO
@@ -2263,8 +2267,8 @@
              nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_x_xy(av), &
                                      netcdf_data, start = (/ 1 /),   &
-                                     count = (/ nx+2 /) )
+                                     count = (/ nx+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 127 )
 
-             DO  i = 0, nx+1
+             DO  i = 0, nx
                 netcdf_data(i) = i * dx
              ENDDO
@@ -2272,5 +2276,5 @@
              nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_xu_xy(av), &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ nx+2 /) )
+                                     count = (/ nx+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 367 )
 
@@ -2281,5 +2285,5 @@
              ALLOCATE( netcdf_data(0:ny+1) )
 
-             DO  i = 0, ny+1
+             DO  i = 0, ny
                 netcdf_data(i) = ( i + 0.5_wp ) * dy
              ENDDO
@@ -2287,8 +2291,8 @@
              nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_y_xy(av), &
                                      netcdf_data, start = (/ 1 /),   &
-                                     count = (/ ny+2 /))
+                                     count = (/ ny+1 /))
              CALL netcdf_handle_error( 'netcdf_define_header', 128 )
 
-             DO  i = 0, ny+1
+             DO  i = 0, ny
                 netcdf_data(i) = i * dy
              ENDDO
@@ -2296,5 +2300,5 @@
              nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_yv_xy(av), &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ ny+2 /))
+                                     count = (/ ny+1 /))
              CALL netcdf_handle_error( 'netcdf_define_header', 368 )
 
@@ -2309,48 +2313,48 @@
                netcdf_data_format > 4  )  THEN
 
-             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zusi_xy(av),     &
-                                        zu_s_inner(nxl:nxr+1,nys:nyn),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
-             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zusi_xy(av),     &
-                                        zu_s_inner(nxl:nxr,nys:nyn+1),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
-             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zusi_xy(av),     &
-                                        zu_s_inner(nxl:nxr+1,nys:nyn+1),       &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
-             ELSE
+!             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zusi_xy(av),     &
+!                                        zu_s_inner(nxl:nxr+1,nys:nyn),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
+!             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zusi_xy(av),     &
+!                                        zu_s_inner(nxl:nxr,nys:nyn+1),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
+!             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zusi_xy(av),     &
+!                                        zu_s_inner(nxl:nxr+1,nys:nyn+1),       &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
+!             ELSE
                 nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zusi_xy(av),     &
                                         zu_s_inner(nxl:nxr,nys:nyn),           &
                                         start = (/ nxl+1, nys+1 /),            &
                                         count = (/ nxr-nxl+1, nyn-nys+1 /) )
-             ENDIF
+!             ENDIF
              CALL netcdf_handle_error( 'netcdf_define_header', 427 )
 
-             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av),     &
-                                        zw_w_inner(nxl:nxr+1,nys:nyn),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
-             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av),     &
-                                        zw_w_inner(nxl:nxr,nys:nyn+1),         &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
-             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
-                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av),     &
-                                        zw_w_inner(nxl:nxr+1,nys:nyn+1),       &
-                                        start = (/ nxl+1, nys+1 /),            &
-                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
-             ELSE
+!             IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av),     &
+!                                        zw_w_inner(nxl:nxr+1,nys:nyn),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+1 /) )
+!             ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av),     &
+!                                        zw_w_inner(nxl:nxr,nys:nyn+1),         &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+1, nyn-nys+2 /) )
+!             ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+!                nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av),     &
+!                                        zw_w_inner(nxl:nxr+1,nys:nyn+1),       &
+!                                        start = (/ nxl+1, nys+1 /),            &
+!                                        count = (/ nxr-nxl+2, nyn-nys+2 /) )
+!             ELSE
                 nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av),     &
                                         zw_w_inner(nxl:nxr,nys:nyn),           &
                                         start = (/ nxl+1, nys+1 /),            &
                                         count = (/ nxr-nxl+1, nyn-nys+1 /) )
-             ENDIF
+!             ENDIF
              CALL netcdf_handle_error( 'netcdf_define_header', 428 )
 
@@ -2684,5 +2688,5 @@
 !
 !--       Define x-axis (for scalar position)
-          CALL netcdf_create_dim( id_set_xz(av), 'x', nx+2, id_dim_x_xz(av),   &
+          CALL netcdf_create_dim( id_set_xz(av), 'x', nx+1, id_dim_x_xz(av),   &
                                   150 )
           CALL netcdf_create_var( id_set_xz(av), (/ id_dim_x_xz(av) /), 'x',   &
@@ -2691,5 +2695,5 @@
 !
 !--       Define x-axis (for u position)
-          CALL netcdf_create_dim( id_set_xz(av), 'xu', nx+2, id_dim_xu_xz(av), &
+          CALL netcdf_create_dim( id_set_xz(av), 'xu', nx+1, id_dim_xu_xz(av), &
                                   372 )
           CALL netcdf_create_var( id_set_xz(av), (/ id_dim_xu_xz(av) /), 'xu', &
@@ -2940,7 +2944,7 @@
 !
 !--          Write data for x (shifted by +dx/2) and xu axis
-             ALLOCATE( netcdf_data(0:nx+1) )
-
-             DO  i = 0, nx+1
+             ALLOCATE( netcdf_data(0:nx) )
+
+             DO  i = 0, nx
                 netcdf_data(i) = ( i + 0.5_wp ) * dx
              ENDDO
@@ -2948,8 +2952,8 @@
              nc_stat = NF90_PUT_VAR( id_set_xz(av), id_var_x_xz(av), &
                                      netcdf_data, start = (/ 1 /),   &
-                                     count = (/ nx+2 /) )
+                                     count = (/ nx+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 165 )
 
-             DO  i = 0, nx+1
+             DO  i = 0, nx
                 netcdf_data(i) = i * dx
              ENDDO
@@ -2957,5 +2961,5 @@
              nc_stat = NF90_PUT_VAR( id_set_xz(av), id_var_xu_xz(av), &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ nx+2 /) )
+                                     count = (/ nx+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 377 )
 
@@ -3337,5 +3341,5 @@
 !
 !--       Define y-axis (for scalar position)
-          CALL netcdf_create_dim( id_set_yz(av), 'y', ny+2, id_dim_y_yz(av),   &
+          CALL netcdf_create_dim( id_set_yz(av), 'y', ny+1, id_dim_y_yz(av),   &
                                   189 )
           CALL netcdf_create_var( id_set_yz(av), (/ id_dim_y_yz(av) /), 'y',   &
@@ -3344,5 +3348,5 @@
 !
 !--       Define y-axis (for v position)
-          CALL netcdf_create_dim( id_set_yz(av), 'yv', ny+2, id_dim_yv_yz(av), &
+          CALL netcdf_create_dim( id_set_yz(av), 'yv', ny+1, id_dim_yv_yz(av), &
                                   380 )
           CALL netcdf_create_var( id_set_yz(av), (/ id_dim_yv_yz(av) /), 'yv', &
@@ -3592,7 +3596,7 @@
 !
 !--          Write data for y (shifted by +dy/2) and yv axis
-             ALLOCATE( netcdf_data(0:ny+1) )
-
-             DO  j = 0, ny+1
+             ALLOCATE( netcdf_data(0:ny) )
+
+             DO  j = 0, ny
                 netcdf_data(j) = ( j + 0.5_wp ) * dy
              ENDDO
@@ -3600,8 +3604,8 @@
              nc_stat = NF90_PUT_VAR( id_set_yz(av), id_var_y_yz(av), &
                                      netcdf_data, start = (/ 1 /),   &
-                                     count = (/ ny+2 /) )
+                                     count = (/ ny+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 204 )
 
-             DO  j = 0, ny+1
+             DO  j = 0, ny
                 netcdf_data(j) = j * dy
              ENDDO
@@ -3609,5 +3613,5 @@
              nc_stat = NF90_PUT_VAR( id_set_yz(av), id_var_yv_yz(av), &
                                      netcdf_data, start = (/ 1 /),    &
-                                     count = (/ ny+2 /) )
+                                     count = (/ ny+1 /) )
              CALL netcdf_handle_error( 'netcdf_define_header', 384 )
 
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 2511)
+++ palm/trunk/SOURCE/palm.f90	(revision 2512)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! user interface required revision updated
+! 
+! 2320 2017-07-21 12:47:43Z suehring
 ! Modularize large-scale forcing and nudging
 ! 
@@ -237,5 +240,5 @@
 
     version = 'PALM 4.0'
-    user_interface_required_revision = 'r2297'
+    user_interface_required_revision = 'r2512'
 
 #if defined( __parallel )
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 2511)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 2512)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! upper bounds of 3d output changed from nx+1,ny+1 to nx,ny
+! no output of ghost layer data
+! 
+! 2318 2017-07-20 17:27:44Z suehring
 ! Get topography top index via Function call 
 ! 
@@ -356,5 +360,5 @@
     LOGICAL      ::  found !< 
 
-    REAL(sp), DIMENSION(nxlg:nxrg,nysg:nyng,nzb:nz_do3d) ::  local_pf !< 
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb:nz_do3d) ::  local_pf !< 
 
 
@@ -365,8 +369,7 @@
 
       CASE ( 'pcm_heatrate' )
-         CALL exchange_horiz( pc_heating_rate, nbgp )
          IF ( av == 0 )  THEN
-            DO  i = nxlg, nxrg
-               DO  j = nysg, nyng
+            DO  i = nxl, nxr
+               DO  j = nys, nyn
                   DO  k = nzb_s_inner(j,i), nz_do3d
                      local_pf(i,j,k) = pc_heating_rate(k-nzb_s_inner(j,i),j,i)
@@ -379,6 +382,6 @@
       CASE ( 'pcm_lad' )
          IF ( av == 0 )  THEN
-            DO  i = nxlg, nxrg
-               DO  j = nysg, nyng
+            DO  i = nxl, nxr
+               DO  j = nys, nyn
                   DO  k = nzb_s_inner(j,i), nz_do3d
                      local_pf(i,j,k) = lad_s(k-nzb_s_inner(j,i),j,i)
